/************************************
Copyright (C) 2010 Kevin Allen

This file is part of kacq.

kacq is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

kacq is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with kacq.  If not, see <http://www.gnu.org/licenses/>.


gcc -Wall -g -o kacq main.c callback.c comedi_code.c recording.c  -export-dynamic `pkg-config --cflags --libs gtk+-2.0`  -lcomedi -lm -lrt -pthread

Date: 01.08.2010
*************************************/
#include <gtk/gtk.h> // for the widgets
#include "main.h" // all functions are declared there
#include <pthread.h> // to be able to create threads
int main (int argc, char *argv[])
{
  gtk_init (&argc, &argv);

  // mutex are used to prevent multiple threads for accessing 
  // a chunk of share memory at the same time
  pthread_mutex_init(&mutex_comedi_interface_buffer, NULL);

  // initialize the comedi_interface
  if (comedi_interface_init()==-1)
    {
      fprintf(stderr,"%s could not initialize comedi_interface\n",argv[0] );
      return 1;
    }
  // initialize the recording_interface
  if (recording_interface_init(&recording_inter)==-1)
    {
      fprintf(stderr,"%s could not initialize recording_interface\n",argv[0] );
      return 1;
    }
  
  // to build the interface from the glade file
  if(init_window()==-1)
    {
      fprintf(stderr,"%s could not build the visual interface\n",argv[0] );
      return 1;
    }
  
    // wait for something to happen
  gtk_main ();
  pthread_mutex_destroy(&mutex_comedi_interface_buffer);

  
  return 0;
}
